/* tslint:disable */
/* eslint-disable */
/**
 * LDS Token Api
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface AccountCreateCommand
 */
export interface AccountCreateCommand {
    /**
     * 
     * @type {string}
     * @memberof AccountCreateCommand
     */
    'userId': string;
}
/**
 * 
 * @export
 * @interface AccountResponse
 */
export interface AccountResponse {
    /**
     * 
     * @type {string}
     * @memberof AccountResponse
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof AccountResponse
     */
    'userId': string;
    /**
     * 
     * @type {string}
     * @memberof AccountResponse
     */
    'address': string;
}
/**
 * 
 * @export
 * @interface BankDetailsEnsureExistsCommand
 */
export interface BankDetailsEnsureExistsCommand {
    /**
     * 
     * @type {string}
     * @memberof BankDetailsEnsureExistsCommand
     */
    'userId': string;
    /**
     * 
     * @type {string}
     * @memberof BankDetailsEnsureExistsCommand
     */
    'card': string;
    /**
     * 
     * @type {string}
     * @memberof BankDetailsEnsureExistsCommand
     */
    'bank': string;
    /**
     * 
     * @type {string}
     * @memberof BankDetailsEnsureExistsCommand
     */
    'firstName': string;
    /**
     * 
     * @type {string}
     * @memberof BankDetailsEnsureExistsCommand
     */
    'lastName': string;
    /**
     * 
     * @type {string}
     * @memberof BankDetailsEnsureExistsCommand
     */
    'patronymic': string;
}
/**
 * 
 * @export
 * @interface BankDetailsName
 */
export interface BankDetailsName {
    /**
     * 
     * @type {string}
     * @memberof BankDetailsName
     */
    'first': string;
    /**
     * 
     * @type {string}
     * @memberof BankDetailsName
     */
    'last': string;
    /**
     * 
     * @type {string}
     * @memberof BankDetailsName
     */
    'patronymic': string;
}
/**
 * 
 * @export
 * @interface BankDetailsResponse
 */
export interface BankDetailsResponse {
    /**
     * 
     * @type {string}
     * @memberof BankDetailsResponse
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof BankDetailsResponse
     */
    'userId': string;
    /**
     * 
     * @type {string}
     * @memberof BankDetailsResponse
     */
    'card': string;
    /**
     * 
     * @type {BankDetailsName}
     * @memberof BankDetailsResponse
     */
    'name': BankDetailsName;
    /**
     * 
     * @type {string}
     * @memberof BankDetailsResponse
     */
    'bank': string;
}
/**
 * 
 * @export
 * @interface CloseOfferCommand
 */
export interface CloseOfferCommand {
    /**
     * offer id
     * @type {string}
     * @memberof CloseOfferCommand
     */
    'id': string;
    /**
     * reject reason
     * @type {string}
     * @memberof CloseOfferCommand
     */
    'note': string;
}
/**
 * 
 * @export
 * @interface ConfirmOfferCommand
 */
export interface ConfirmOfferCommand {
    /**
     * 
     * @type {string}
     * @memberof ConfirmOfferCommand
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof ConfirmOfferCommand
     */
    'userId': string;
}
/**
 * 
 * @export
 * @interface CreateOfferCommand
 */
export interface CreateOfferCommand {
    /**
     * 
     * @type {string}
     * @memberof CreateOfferCommand
     */
    'ownerId': string;
    /**
     * 
     * @type {string}
     * @memberof CreateOfferCommand
     */
    'amount': string;
    /**
     * 
     * @type {number}
     * @memberof CreateOfferCommand
     */
    'price': number;
    /**
     * 
     * @type {OfferTypeEnum}
     * @memberof CreateOfferCommand
     */
    'type': OfferTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof CreateOfferCommand
     */
    'publishAt': string;
}
/**
 * 
 * @export
 * @interface CreatePaymentResult
 */
export interface CreatePaymentResult {
    /**
     * 
     * @type {string}
     * @memberof CreatePaymentResult
     */
    'paymentUrl': string;
}
/**
 * 
 * @export
 * @interface OfferListResponse
 */
export interface OfferListResponse {
    /**
     * 
     * @type {PaginationResponse}
     * @memberof OfferListResponse
     */
    'pagination': PaginationResponse;
    /**
     * 
     * @type {Array<OfferResponse>}
     * @memberof OfferListResponse
     */
    'items': Array<OfferResponse>;
}
/**
 * 
 * @export
 * @interface OfferResponse
 */
export interface OfferResponse {
    /**
     * 
     * @type {string}
     * @memberof OfferResponse
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof OfferResponse
     */
    'amount': string;
    /**
     * 
     * @type {Rate}
     * @memberof OfferResponse
     */
    'rate': Rate;
    /**
     * 
     * @type {OfferStatusEnum}
     * @memberof OfferResponse
     */
    'status': OfferStatusEnum;
    /**
     * 
     * @type {OfferTypeEnum}
     * @memberof OfferResponse
     */
    'type': OfferTypeEnum;
    /**
     * 
     * @type {AccountResponse}
     * @memberof OfferResponse
     */
    'owner': AccountResponse;
    /**
     * 
     * @type {AccountResponse}
     * @memberof OfferResponse
     */
    'reservedBy': AccountResponse | null;
    /**
     * 
     * @type {string}
     * @memberof OfferResponse
     */
    'reservedAt': string | null;
    /**
     * 
     * @type {BankDetailsResponse}
     * @memberof OfferResponse
     */
    'bankDetails': BankDetailsResponse | null;
    /**
     * 
     * @type {string}
     * @memberof OfferResponse
     */
    'publishedAt': string;
    /**
     * 
     * @type {string}
     * @memberof OfferResponse
     */
    'createdAt': string;
    /**
     * 
     * @type {string}
     * @memberof OfferResponse
     */
    'updatedAt': string;
}
/**
 * 
 * @export
 * @enum {string}
 */

export enum OfferStatusEnum {
    Opened = 'OPENED',
    Reserved = 'RESERVED',
    Fulfilled = 'FULFILLED',
    Closed = 'CLOSED'
}

/**
 * 
 * @export
 * @enum {string}
 */

export enum OfferTypeEnum {
    Buy = 'BUY',
    Sell = 'SELL'
}

/**
 * 
 * @export
 * @interface PaginationResponse
 */
export interface PaginationResponse {
    /**
     * 
     * @type {string}
     * @memberof PaginationResponse
     */
    'order'?: string;
    /**
     * 
     * @type {string}
     * @memberof PaginationResponse
     */
    'orderBy'?: PaginationResponseOrderByEnum;
    /**
     * 
     * @type {number}
     * @memberof PaginationResponse
     */
    'page'?: number;
    /**
     * 
     * @type {number}
     * @memberof PaginationResponse
     */
    'pageSize'?: number;
    /**
     * 
     * @type {number}
     * @memberof PaginationResponse
     */
    'total'?: number | null;
}

/**
    * @export
    * @enum {string}
    */
export enum PaginationResponseOrderByEnum {
    Asc = 'ASC',
    Desc = 'DESC'
}

/**
 * 
 * @export
 * @interface PayOfferCommand
 */
export interface PayOfferCommand {
    /**
     * 
     * @type {string}
     * @memberof PayOfferCommand
     */
    'id': string;
    /**
     * user id
     * @type {string}
     * @memberof PayOfferCommand
     */
    'reservedBy': string;
}
/**
 * 
 * @export
 * @interface PaymentNotification
 */
export interface PaymentNotification {
    /**
     * 
     * @type {string}
     * @memberof PaymentNotification
     */
    'TerminalKey': string;
    /**
     * 
     * @type {string}
     * @memberof PaymentNotification
     */
    'OrderId': string;
    /**
     * 
     * @type {boolean}
     * @memberof PaymentNotification
     */
    'Success': boolean;
    /**
     * 
     * @type {string}
     * @memberof PaymentNotification
     */
    'Status': string;
    /**
     * 
     * @type {number}
     * @memberof PaymentNotification
     */
    'PaymentId': number;
    /**
     * 
     * @type {string}
     * @memberof PaymentNotification
     */
    'ErrorCode': string;
    /**
     * 
     * @type {number}
     * @memberof PaymentNotification
     */
    'Amount': number;
    /**
     * 
     * @type {number}
     * @memberof PaymentNotification
     */
    'RebillId': number;
    /**
     * 
     * @type {number}
     * @memberof PaymentNotification
     */
    'CardId': number;
    /**
     * 
     * @type {string}
     * @memberof PaymentNotification
     */
    'Pan': string;
    /**
     * 
     * @type {string}
     * @memberof PaymentNotification
     */
    'ExpDate': string;
    /**
     * 
     * @type {string}
     * @memberof PaymentNotification
     */
    'Token': string;
    /**
     * 
     * @type {object}
     * @memberof PaymentNotification
     */
    'Data': object;
}
/**
 * 
 * @export
 * @interface Rate
 */
export interface Rate {
    /**
     * 
     * @type {string}
     * @memberof Rate
     */
    'currency': string;
    /**
     * 
     * @type {number}
     * @memberof Rate
     */
    'price': number;
}
/**
 * 
 * @export
 * @interface ReserveOfferCommand
 */
export interface ReserveOfferCommand {
    /**
     * 
     * @type {string}
     * @memberof ReserveOfferCommand
     */
    'id': string;
    /**
     * user id
     * @type {string}
     * @memberof ReserveOfferCommand
     */
    'reservedBy': string;
    /**
     * 
     * @type {string}
     * @memberof ReserveOfferCommand
     */
    'bankDetails'?: string;
}
/**
 * 
 * @export
 * @interface TransferCommand
 */
export interface TransferCommand {
    /**
     * account user id
     * @type {string}
     * @memberof TransferCommand
     */
    'sender': string;
    /**
     * 
     * @type {string}
     * @memberof TransferCommand
     */
    'recipient': string;
    /**
     * 
     * @type {string}
     * @memberof TransferCommand
     */
    'amount': string;
}

/**
 * AccountApi - axios parameter creator
 * @export
 */
export const AccountApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {AccountCreateCommand} accountCreateCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        create: async (accountCreateCommand: AccountCreateCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'accountCreateCommand' is not null or undefined
            assertParamExists('create', 'accountCreateCommand', accountCreateCommand)
            const localVarPath = `/api/ledius-token/accounts`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(accountCreateCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        list: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/ledius-token/accounts`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userAccount: async (userId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'userId' is not null or undefined
            assertParamExists('userAccount', 'userId', userId)
            const localVarPath = `/api/ledius-token/accounts/{userId}/user`
                .replace(`{${"userId"}}`, encodeURIComponent(String(userId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AccountApi - functional programming interface
 * @export
 */
export const AccountApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = AccountApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {AccountCreateCommand} accountCreateCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async create(accountCreateCommand: AccountCreateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AccountResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.create(accountCreateCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async list(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<AccountResponse>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.list(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {string} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userAccount(userId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AccountResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.userAccount(userId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * AccountApi - factory interface
 * @export
 */
export const AccountApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = AccountApiFp(configuration)
    return {
        /**
         * 
         * @param {AccountCreateCommand} accountCreateCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        create(accountCreateCommand: AccountCreateCommand, options?: any): AxiosPromise<AccountResponse> {
            return localVarFp.create(accountCreateCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        list(options?: any): AxiosPromise<Array<AccountResponse>> {
            return localVarFp.list(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {string} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userAccount(userId: string, options?: any): AxiosPromise<AccountResponse> {
            return localVarFp.userAccount(userId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for create operation in AccountApi.
 * @export
 * @interface AccountApiCreateRequest
 */
export interface AccountApiCreateRequest {
    /**
     * 
     * @type {AccountCreateCommand}
     * @memberof AccountApiCreate
     */
    readonly accountCreateCommand: AccountCreateCommand
}

/**
 * Request parameters for userAccount operation in AccountApi.
 * @export
 * @interface AccountApiUserAccountRequest
 */
export interface AccountApiUserAccountRequest {
    /**
     * 
     * @type {string}
     * @memberof AccountApiUserAccount
     */
    readonly userId: string
}

/**
 * AccountApi - object-oriented interface
 * @export
 * @class AccountApi
 * @extends {BaseAPI}
 */
export class AccountApi extends BaseAPI {
    /**
     * 
     * @param {AccountApiCreateRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccountApi
     */
    public create(requestParameters: AccountApiCreateRequest, options?: AxiosRequestConfig) {
        return AccountApiFp(this.configuration).create(requestParameters.accountCreateCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccountApi
     */
    public list(options?: AxiosRequestConfig) {
        return AccountApiFp(this.configuration).list(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {AccountApiUserAccountRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccountApi
     */
    public userAccount(requestParameters: AccountApiUserAccountRequest, options?: AxiosRequestConfig) {
        return AccountApiFp(this.configuration).userAccount(requestParameters.userId, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * BalanceApi - axios parameter creator
 * @export
 */
export const BalanceApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string} address 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        accountBalance: async (address: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'address' is not null or undefined
            assertParamExists('accountBalance', 'address', address)
            const localVarPath = `/api/ledius-token/balance/account`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (address !== undefined) {
                localVarQueryParameter['address'] = address;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * BalanceApi - functional programming interface
 * @export
 */
export const BalanceApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = BalanceApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {string} address 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async accountBalance(address: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.accountBalance(address, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * BalanceApi - factory interface
 * @export
 */
export const BalanceApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = BalanceApiFp(configuration)
    return {
        /**
         * 
         * @param {string} address 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        accountBalance(address: string, options?: any): AxiosPromise<void> {
            return localVarFp.accountBalance(address, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for accountBalance operation in BalanceApi.
 * @export
 * @interface BalanceApiAccountBalanceRequest
 */
export interface BalanceApiAccountBalanceRequest {
    /**
     * 
     * @type {string}
     * @memberof BalanceApiAccountBalance
     */
    readonly address: string
}

/**
 * BalanceApi - object-oriented interface
 * @export
 * @class BalanceApi
 * @extends {BaseAPI}
 */
export class BalanceApi extends BaseAPI {
    /**
     * 
     * @param {BalanceApiAccountBalanceRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof BalanceApi
     */
    public accountBalance(requestParameters: BalanceApiAccountBalanceRequest, options?: AxiosRequestConfig) {
        return BalanceApiFp(this.configuration).accountBalance(requestParameters.address, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * BankDetailsApi - axios parameter creator
 * @export
 */
export const BankDetailsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {BankDetailsEnsureExistsCommand} bankDetailsEnsureExistsCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        ensure: async (bankDetailsEnsureExistsCommand: BankDetailsEnsureExistsCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'bankDetailsEnsureExistsCommand' is not null or undefined
            assertParamExists('ensure', 'bankDetailsEnsureExistsCommand', bankDetailsEnsureExistsCommand)
            const localVarPath = `/api/ledius-token/banks-details/ensure`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(bankDetailsEnsureExistsCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} [userId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        list: async (userId?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/ledius-token/banks-details`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (userId !== undefined) {
                localVarQueryParameter['userId'] = userId;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * BankDetailsApi - functional programming interface
 * @export
 */
export const BankDetailsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = BankDetailsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {BankDetailsEnsureExistsCommand} bankDetailsEnsureExistsCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async ensure(bankDetailsEnsureExistsCommand: BankDetailsEnsureExistsCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BankDetailsResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.ensure(bankDetailsEnsureExistsCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {string} [userId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async list(userId?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<BankDetailsResponse>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.list(userId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * BankDetailsApi - factory interface
 * @export
 */
export const BankDetailsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = BankDetailsApiFp(configuration)
    return {
        /**
         * 
         * @param {BankDetailsEnsureExistsCommand} bankDetailsEnsureExistsCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        ensure(bankDetailsEnsureExistsCommand: BankDetailsEnsureExistsCommand, options?: any): AxiosPromise<BankDetailsResponse> {
            return localVarFp.ensure(bankDetailsEnsureExistsCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {string} [userId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        list(userId?: string, options?: any): AxiosPromise<Array<BankDetailsResponse>> {
            return localVarFp.list(userId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for ensure operation in BankDetailsApi.
 * @export
 * @interface BankDetailsApiEnsureRequest
 */
export interface BankDetailsApiEnsureRequest {
    /**
     * 
     * @type {BankDetailsEnsureExistsCommand}
     * @memberof BankDetailsApiEnsure
     */
    readonly bankDetailsEnsureExistsCommand: BankDetailsEnsureExistsCommand
}

/**
 * Request parameters for list operation in BankDetailsApi.
 * @export
 * @interface BankDetailsApiListRequest
 */
export interface BankDetailsApiListRequest {
    /**
     * 
     * @type {string}
     * @memberof BankDetailsApiList
     */
    readonly userId?: string
}

/**
 * BankDetailsApi - object-oriented interface
 * @export
 * @class BankDetailsApi
 * @extends {BaseAPI}
 */
export class BankDetailsApi extends BaseAPI {
    /**
     * 
     * @param {BankDetailsApiEnsureRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof BankDetailsApi
     */
    public ensure(requestParameters: BankDetailsApiEnsureRequest, options?: AxiosRequestConfig) {
        return BankDetailsApiFp(this.configuration).ensure(requestParameters.bankDetailsEnsureExistsCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {BankDetailsApiListRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof BankDetailsApi
     */
    public list(requestParameters: BankDetailsApiListRequest = {}, options?: AxiosRequestConfig) {
        return BankDetailsApiFp(this.configuration).list(requestParameters.userId, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * OfferApi - axios parameter creator
 * @export
 */
export const OfferApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {CloseOfferCommand} closeOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        close: async (closeOfferCommand: CloseOfferCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'closeOfferCommand' is not null or undefined
            assertParamExists('close', 'closeOfferCommand', closeOfferCommand)
            const localVarPath = `/api/ledius-token/offers/close`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(closeOfferCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {CreateOfferCommand} createOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        create: async (createOfferCommand: CreateOfferCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'createOfferCommand' is not null or undefined
            assertParamExists('create', 'createOfferCommand', createOfferCommand)
            const localVarPath = `/api/ledius-token/offers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createOfferCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {number} [type] 
         * @param {number} [status] 
         * @param {string} [paginationOrderBy] 
         * @param {'ASC' | 'DESC'} [paginationOrder] 
         * @param {number} [paginationPage] 
         * @param {number} [paginationPageSize] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        list: async (type?: number, status?: number, paginationOrderBy?: string, paginationOrder?: 'ASC' | 'DESC', paginationPage?: number, paginationPageSize?: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/ledius-token/offers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (type !== undefined) {
                localVarQueryParameter['type'] = type;
            }

            if (status !== undefined) {
                localVarQueryParameter['status'] = status;
            }

            if (paginationOrderBy !== undefined) {
                localVarQueryParameter['pagination[orderBy]'] = paginationOrderBy;
            }

            if (paginationOrder !== undefined) {
                localVarQueryParameter['pagination[order]'] = paginationOrder;
            }

            if (paginationPage !== undefined) {
                localVarQueryParameter['pagination[page]'] = paginationPage;
            }

            if (paginationPageSize !== undefined) {
                localVarQueryParameter['pagination[pageSize]'] = paginationPageSize;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {PayOfferCommand} payOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        pay: async (payOfferCommand: PayOfferCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'payOfferCommand' is not null or undefined
            assertParamExists('pay', 'payOfferCommand', payOfferCommand)
            const localVarPath = `/api/ledius-token/offers/pay`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(payOfferCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {PaymentNotification} paymentNotification 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        payConfirm: async (paymentNotification: PaymentNotification, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'paymentNotification' is not null or undefined
            assertParamExists('payConfirm', 'paymentNotification', paymentNotification)
            const localVarPath = `/api/ledius-token/offers/confirm`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(paymentNotification, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {ReserveOfferCommand} reserveOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reserve: async (reserveOfferCommand: ReserveOfferCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'reserveOfferCommand' is not null or undefined
            assertParamExists('reserve', 'reserveOfferCommand', reserveOfferCommand)
            const localVarPath = `/api/ledius-token/offers/reserve`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(reserveOfferCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {ConfirmOfferCommand} confirmOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reserveConfirm: async (confirmOfferCommand: ConfirmOfferCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'confirmOfferCommand' is not null or undefined
            assertParamExists('reserveConfirm', 'confirmOfferCommand', confirmOfferCommand)
            const localVarPath = `/api/ledius-token/offers/reserve/confirm`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(confirmOfferCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * OfferApi - functional programming interface
 * @export
 */
export const OfferApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = OfferApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {CloseOfferCommand} closeOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async close(closeOfferCommand: CloseOfferCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OfferResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.close(closeOfferCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {CreateOfferCommand} createOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async create(createOfferCommand: CreateOfferCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OfferResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.create(createOfferCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {number} [type] 
         * @param {number} [status] 
         * @param {string} [paginationOrderBy] 
         * @param {'ASC' | 'DESC'} [paginationOrder] 
         * @param {number} [paginationPage] 
         * @param {number} [paginationPageSize] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async list(type?: number, status?: number, paginationOrderBy?: string, paginationOrder?: 'ASC' | 'DESC', paginationPage?: number, paginationPageSize?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OfferListResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.list(type, status, paginationOrderBy, paginationOrder, paginationPage, paginationPageSize, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {PayOfferCommand} payOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async pay(payOfferCommand: PayOfferCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CreatePaymentResult>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.pay(payOfferCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {PaymentNotification} paymentNotification 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async payConfirm(paymentNotification: PaymentNotification, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.payConfirm(paymentNotification, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {ReserveOfferCommand} reserveOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reserve(reserveOfferCommand: ReserveOfferCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OfferResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.reserve(reserveOfferCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {ConfirmOfferCommand} confirmOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async reserveConfirm(confirmOfferCommand: ConfirmOfferCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OfferResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.reserveConfirm(confirmOfferCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * OfferApi - factory interface
 * @export
 */
export const OfferApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = OfferApiFp(configuration)
    return {
        /**
         * 
         * @param {CloseOfferCommand} closeOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        close(closeOfferCommand: CloseOfferCommand, options?: any): AxiosPromise<OfferResponse> {
            return localVarFp.close(closeOfferCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {CreateOfferCommand} createOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        create(createOfferCommand: CreateOfferCommand, options?: any): AxiosPromise<OfferResponse> {
            return localVarFp.create(createOfferCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {number} [type] 
         * @param {number} [status] 
         * @param {string} [paginationOrderBy] 
         * @param {'ASC' | 'DESC'} [paginationOrder] 
         * @param {number} [paginationPage] 
         * @param {number} [paginationPageSize] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        list(type?: number, status?: number, paginationOrderBy?: string, paginationOrder?: 'ASC' | 'DESC', paginationPage?: number, paginationPageSize?: number, options?: any): AxiosPromise<OfferListResponse> {
            return localVarFp.list(type, status, paginationOrderBy, paginationOrder, paginationPage, paginationPageSize, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {PayOfferCommand} payOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        pay(payOfferCommand: PayOfferCommand, options?: any): AxiosPromise<CreatePaymentResult> {
            return localVarFp.pay(payOfferCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {PaymentNotification} paymentNotification 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        payConfirm(paymentNotification: PaymentNotification, options?: any): AxiosPromise<void> {
            return localVarFp.payConfirm(paymentNotification, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {ReserveOfferCommand} reserveOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reserve(reserveOfferCommand: ReserveOfferCommand, options?: any): AxiosPromise<OfferResponse> {
            return localVarFp.reserve(reserveOfferCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {ConfirmOfferCommand} confirmOfferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        reserveConfirm(confirmOfferCommand: ConfirmOfferCommand, options?: any): AxiosPromise<OfferResponse> {
            return localVarFp.reserveConfirm(confirmOfferCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for close operation in OfferApi.
 * @export
 * @interface OfferApiCloseRequest
 */
export interface OfferApiCloseRequest {
    /**
     * 
     * @type {CloseOfferCommand}
     * @memberof OfferApiClose
     */
    readonly closeOfferCommand: CloseOfferCommand
}

/**
 * Request parameters for create operation in OfferApi.
 * @export
 * @interface OfferApiCreateRequest
 */
export interface OfferApiCreateRequest {
    /**
     * 
     * @type {CreateOfferCommand}
     * @memberof OfferApiCreate
     */
    readonly createOfferCommand: CreateOfferCommand
}

/**
 * Request parameters for list operation in OfferApi.
 * @export
 * @interface OfferApiListRequest
 */
export interface OfferApiListRequest {
    /**
     * 
     * @type {number}
     * @memberof OfferApiList
     */
    readonly type?: number

    /**
     * 
     * @type {number}
     * @memberof OfferApiList
     */
    readonly status?: number

    /**
     * 
     * @type {string}
     * @memberof OfferApiList
     */
    readonly paginationOrderBy?: string

    /**
     * 
     * @type {'ASC' | 'DESC'}
     * @memberof OfferApiList
     */
    readonly paginationOrder?: 'ASC' | 'DESC'

    /**
     * 
     * @type {number}
     * @memberof OfferApiList
     */
    readonly paginationPage?: number

    /**
     * 
     * @type {number}
     * @memberof OfferApiList
     */
    readonly paginationPageSize?: number
}

/**
 * Request parameters for pay operation in OfferApi.
 * @export
 * @interface OfferApiPayRequest
 */
export interface OfferApiPayRequest {
    /**
     * 
     * @type {PayOfferCommand}
     * @memberof OfferApiPay
     */
    readonly payOfferCommand: PayOfferCommand
}

/**
 * Request parameters for payConfirm operation in OfferApi.
 * @export
 * @interface OfferApiPayConfirmRequest
 */
export interface OfferApiPayConfirmRequest {
    /**
     * 
     * @type {PaymentNotification}
     * @memberof OfferApiPayConfirm
     */
    readonly paymentNotification: PaymentNotification
}

/**
 * Request parameters for reserve operation in OfferApi.
 * @export
 * @interface OfferApiReserveRequest
 */
export interface OfferApiReserveRequest {
    /**
     * 
     * @type {ReserveOfferCommand}
     * @memberof OfferApiReserve
     */
    readonly reserveOfferCommand: ReserveOfferCommand
}

/**
 * Request parameters for reserveConfirm operation in OfferApi.
 * @export
 * @interface OfferApiReserveConfirmRequest
 */
export interface OfferApiReserveConfirmRequest {
    /**
     * 
     * @type {ConfirmOfferCommand}
     * @memberof OfferApiReserveConfirm
     */
    readonly confirmOfferCommand: ConfirmOfferCommand
}

/**
 * OfferApi - object-oriented interface
 * @export
 * @class OfferApi
 * @extends {BaseAPI}
 */
export class OfferApi extends BaseAPI {
    /**
     * 
     * @param {OfferApiCloseRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OfferApi
     */
    public close(requestParameters: OfferApiCloseRequest, options?: AxiosRequestConfig) {
        return OfferApiFp(this.configuration).close(requestParameters.closeOfferCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {OfferApiCreateRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OfferApi
     */
    public create(requestParameters: OfferApiCreateRequest, options?: AxiosRequestConfig) {
        return OfferApiFp(this.configuration).create(requestParameters.createOfferCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {OfferApiListRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OfferApi
     */
    public list(requestParameters: OfferApiListRequest = {}, options?: AxiosRequestConfig) {
        return OfferApiFp(this.configuration).list(requestParameters.type, requestParameters.status, requestParameters.paginationOrderBy, requestParameters.paginationOrder, requestParameters.paginationPage, requestParameters.paginationPageSize, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {OfferApiPayRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OfferApi
     */
    public pay(requestParameters: OfferApiPayRequest, options?: AxiosRequestConfig) {
        return OfferApiFp(this.configuration).pay(requestParameters.payOfferCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {OfferApiPayConfirmRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OfferApi
     */
    public payConfirm(requestParameters: OfferApiPayConfirmRequest, options?: AxiosRequestConfig) {
        return OfferApiFp(this.configuration).payConfirm(requestParameters.paymentNotification, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {OfferApiReserveRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OfferApi
     */
    public reserve(requestParameters: OfferApiReserveRequest, options?: AxiosRequestConfig) {
        return OfferApiFp(this.configuration).reserve(requestParameters.reserveOfferCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {OfferApiReserveConfirmRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OfferApi
     */
    public reserveConfirm(requestParameters: OfferApiReserveConfirmRequest, options?: AxiosRequestConfig) {
        return OfferApiFp(this.configuration).reserveConfirm(requestParameters.confirmOfferCommand, options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * TransferApi - axios parameter creator
 * @export
 */
export const TransferApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {TransferCommand} transferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        transfer: async (transferCommand: TransferCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'transferCommand' is not null or undefined
            assertParamExists('transfer', 'transferCommand', transferCommand)
            const localVarPath = `/api/ledius-token/transfer`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearer required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(transferCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TransferApi - functional programming interface
 * @export
 */
export const TransferApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = TransferApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {TransferCommand} transferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async transfer(transferCommand: TransferCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.transfer(transferCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * TransferApi - factory interface
 * @export
 */
export const TransferApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = TransferApiFp(configuration)
    return {
        /**
         * 
         * @param {TransferCommand} transferCommand 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        transfer(transferCommand: TransferCommand, options?: any): AxiosPromise<void> {
            return localVarFp.transfer(transferCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for transfer operation in TransferApi.
 * @export
 * @interface TransferApiTransferRequest
 */
export interface TransferApiTransferRequest {
    /**
     * 
     * @type {TransferCommand}
     * @memberof TransferApiTransfer
     */
    readonly transferCommand: TransferCommand
}

/**
 * TransferApi - object-oriented interface
 * @export
 * @class TransferApi
 * @extends {BaseAPI}
 */
export class TransferApi extends BaseAPI {
    /**
     * 
     * @param {TransferApiTransferRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TransferApi
     */
    public transfer(requestParameters: TransferApiTransferRequest, options?: AxiosRequestConfig) {
        return TransferApiFp(this.configuration).transfer(requestParameters.transferCommand, options).then((request) => request(this.axios, this.basePath));
    }
}


